diff --git a/hardware/openzwave/platform/HttpClient.h b/hardware/openzwave/platform/HttpClient.h
new file mode 100644
index 0000000000..4c667c73d4
--- /dev/null
+++ b/hardware/openzwave/platform/HttpClient.h
@@ -0,0 +1,384 @@
+//-----------------------------------------------------------------------------
+//
+//	HttpClient.h
+//
+//	Cross-platform HttpClient
+//
+//  Originally based upon minihttp client
+//	Copyright (c) 2016 Justin Hammond <Justin@dynam.ac>
+//
+//	SOFTWARE NOTICE AND LICENSE
+//
+//	This file is part of OpenZWave.
+//
+//	OpenZWave is free software: you can redistribute it and/or modify
+//	it under the terms of the GNU Lesser General Public License as published
+//	by the Free Software Foundation, either version 3 of the License,
+//	or (at your option) any later version.
+//
+//	OpenZWave is distributed in the hope that it will be useful,
+//	but WITHOUT ANY WARRANTY; without even the implied warranty of
+//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//	GNU Lesser General Public License for more details.
+//
+//	You should have received a copy of the GNU Lesser General Public License
+//	along with OpenZWave.  If not, see <http://www.gnu.org/licenses/>.
+//
+//-----------------------------------------------------------------------------
+
+// Original License Text:
+/* This program is free software. It comes without any warranty, to
+* the extent permitted by applicable law. You can redistribute it
+* and/or modify it under the terms of the Do What The Fuck You Want
+* To Public License, Version 2, as published by Sam Hocevar.
+* See http://sam.zoy.org/wtfpl/COPYING for more details. */
+
+#ifndef MINIHTTPSOCKET_H
+#define MINIHTTPSOCKET_H
+
+// ---- Compile config -----
+#define MINIHTTP_SUPPORT_HTTP
+#define MINIHTTP_SUPPORT_SOCKET_SET
+// -------------------------
+
+// Intentionally avoid pulling in any other headers
+
+#include <string>
+#include <map>
+#include <queue>
+
+
+namespace OpenZWave
+{
+/** \defgroup SimpleHttpClient Basic HTTP(s) Client
+ *
+ * a Basic HTTP Client for talking to webservers
+ */
+
+namespace SimpleHTTPClient
+{
+
+/** \brief Initialize the Network for HTTP requests
+  * \ingroup SimpleHttpClient
+  *
+  * Initializes the Network for HTTP requests
+  *
+  * \returns success/failure
+  */
+bool InitNetwork();
+
+/** \brief Stop the Network for HTTP requests
+  * \ingroup SimpleHttpClient
+  *
+  * Stops the Network for HTTP requests and releases resources associated with it
+  */
+void StopNetwork();
+
+/** \brief Indicates if we support HTTPS requests
+  * \ingroup SimpleHttpClient
+  *
+  * Indicates if we support HTTPS requests
+  *
+  * \returns success/failure
+  * \todo SSL is not actually implemented yet.
+  */
+bool HasSSL();
+
+/** \brief Split a URL into its different parts/ports etc
+  * \ingroup SimpleHttpClient
+  *
+  * Split a URL Into the different parts/ports
+  *
+  * \param uri the URL to parse
+  * \param host the Hostname of the URL
+  * \param file the directory/file name of the URL
+  * \param port the port number of the URL, or 80 if not specified
+  *
+  * \returns success/failure
+  */
+bool SplitURI(const std::string& uri, std::string& host, std::string& file, int& port);
+
+/** \brief Encode a String suitable for sending as a URL request (eg Get)
+  * \ingroup SimpleHttpClient
+  *
+  * Encode a String so it can be sent as part of a URL request
+  *
+  * \param s the string to encode
+  * \param enc the encoded version of the string that is returned
+  *
+  */
+void URLEncode(const std::string& s, std::string& enc);
+
+/** \brief Result Codes for SSL operations
+  * \ingroup SimpleHttpClient
+  *
+  */
+enum SSLResult
+{
+    SSLR_OK = 0x0, 						/**< No Error */
+    SSLR_NO_SSL = 0x1,					/**< SSL Is not required */
+    SSLR_FAIL = 0x2,					/**< Internal SSL Engine Failure */
+    SSLR_CERT_EXPIRED = 0x4,			/**< SSL Certificate has expired */
+    SSLR_CERT_REVOKED = 0x8,			/**< SSL Certificate is revoked */
+    SSLR_CERT_CN_MISMATCH = 0x10,		/**< SSL CN Name does not match Hostname */
+    SSLR_CERT_NOT_TRUSTED = 0x20,		/**< SSL Certificate is not trusted */
+    SSLR_CERT_MISSING = 0x40,			/**< SSL Certificate is missing */
+    SSLR_CERT_SKIP_VERIFY = 0x80,		/**< SSL Certificate Verification is disabled */
+    SSLR_CERT_FUTURE = 0x100,			/**< SSL Certificate is valid in the future */
+
+    _SSLR_FORCE32BIT = 0x7fffffff
+};
+
+/** \brief a TCP Socket that can optionally be protected via SSL
+  * \ingroup SimpleHttpClient
+  *
+  * This represents a TCP Socket that can be encrypted via SSL and
+  * is used to connect to a TCP Server (in this case, a HTTP(s) Server
+  */
+class TcpSocket
+{
+public:
+    TcpSocket();
+    virtual ~TcpSocket();
+
+    virtual bool HasPendingTask() const { return false; }
+
+    bool open(const char *addr = NULL, unsigned int port = 0);
+    void close();
+    bool update(); // returns true if something interesting happened (incoming data, closed connection, etc)
+
+    bool isOpen(void);
+
+    void SetBufsizeIn(unsigned int s);
+    bool SetNonBlocking(bool nonblock);
+    unsigned int GetBufSize() { return _inbufSize; }
+    const char *GetHost(void) { return _host.c_str(); }
+    bool SendBytes(const void *buf, unsigned int len);
+
+    // SSL related
+    bool initSSL(const char *certs);
+    bool hasSSL() const { return !!_sslctx; }
+    void shutdownSSL();
+    SSLResult verifySSL();
+
+protected:
+    virtual void _OnCloseInternal();
+    virtual void _OnData(); // data received callback. Internal, should only be overloaded to call _OnRecv()
+
+    virtual void _OnRecv(void *buf, unsigned int size) = 0;
+    virtual void _OnClose() {}; // close callback
+    virtual void _OnOpen() {} // called when opened
+    virtual bool _OnUpdate() { return true; } // called before reading from the socket
+
+    void _ShiftBuffer();
+
+    char *_inbuf;
+    char *_readptr; // part of inbuf, optionally skipped header
+    char *_writeptr; // passed to recv(). usually equal to _inbuf, but may point inside the buffer in case of a partial transfer.
+
+    unsigned int _inbufSize; // size of internal buffer
+    unsigned int _writeSize; // how many bytes can be written to _writeptr;
+    unsigned int _recvSize; // incoming size, max _inbufSize - 1
+
+    unsigned int _lastport; // port used in last open() call
+
+    bool _nonblocking; // Default true. If false, the current thread is blocked while waiting for input.
+
+#ifdef _WIN32
+    intptr_t _s; // socket handle. really an int, but to be sure its 64 bit compatible as it seems required on windows, we use this.
+#else
+    long _s;
+#endif
+
+    std::string _host;
+
+private:
+    int _writeBytes(const unsigned char *buf, size_t len);
+    int _readBytes(unsigned char *buf, size_t maxlen);
+    void *_sslctx;
+};
+
+#ifdef MINIHTTP_SUPPORT_HTTP
+
+enum HttpCode
+{
+    HTTP_OK = 200,
+    HTTP_NOTFOUND = 404,
+};
+
+/** \brief This class is used for Posting data to a HTTP(s) server
+  * \ingroup SimpleHttpClient
+  *
+  * Post some data to a HTTP(s) server
+  *
+  */
+class POST
+{
+public:
+    void reserve(size_t res) { data.reserve(res); }
+    POST& add(const char *key, const char *value);
+    const char *c_str() const { return data.c_str(); }
+    const std::string& str() const { return data; }
+    bool empty() const { return data.empty(); }
+    size_t length() const { return data.length(); }
+private:
+    std::string data;
+};
+
+/** \brief Main class for making a HTTP request to a HTTP(s) server
+  * \ingroup SimpleHttpClient
+  *
+  * Make a request to a HTTP Server
+  *
+  */
+struct Request
+{
+    Request() : port(80), user(NULL) {}
+    Request(const std::string& h, const std::string& res, int p = 80, void *u = NULL)
+        : host(h), resource(res), port(80), user(u), useSSL(false) {}
+
+    std::string protocol;
+    std::string host;
+    std::string header; // set by socket
+    std::string resource;
+    std::string extraGetHeaders;
+    int port;
+    void *user;
+    bool useSSL;
+    POST post; // if this is empty, it's a GET request, otherwise a POST request
+};
+
+/** \brief a Socket that speaks HTTP protocol.
+  * \ingroup SimpleHttpClient
+  *
+  * Talk to a HTTP(s) server
+  *
+  */
+class HttpSocket : public OpenZWave::SimpleHTTPClient::TcpSocket
+{
+public:
+
+    HttpSocket();
+    virtual ~HttpSocket();
+
+    virtual bool HasPendingTask() const
+    {
+        return ExpectMoreData() || _requestQ.size();
+    }
+
+    void SetKeepAlive(unsigned int secs) { _keep_alive = secs; }
+    void SetUserAgent(const std::string &s) { _user_agent = s; }
+    void SetAcceptEncoding(const std::string& s) { _accept_encoding = s; }
+    void SetFollowRedirect(bool follow) { _followRedir = follow; }
+    void SetAlwaysHandle(bool h) { _alwaysHandle = h; }
+    void SetDownloadFile(std::string filename) { _filename = filename; }
+
+    bool Download(const std::string& url, const char *extraRequest = NULL, void *user = NULL, const POST *post = NULL);
+    bool SendRequest(Request& what, bool enqueue);
+    bool SendRequest(const std::string what, const char *extraRequest = NULL, void *user = NULL);
+    bool QueueRequest(const std::string what, const char *extraRequest = NULL, void *user = NULL);
+
+    unsigned int GetRemaining() const { return _remaining; }
+
+    unsigned int GetStatusCode() const { return _status; }
+    unsigned int GetContentLen() const { return _contentLen; }
+    bool ChunkedTransfer() const { return _chunkedTransfer; }
+    bool ExpectMoreData() const { return _remaining || _chunkedTransfer; }
+
+    const Request &GetCurrentRequest() const { return _curRequest; }
+    const char *Hdr(const char *h) const;
+
+    bool IsRedirecting() const;
+    bool IsSuccess() const;
+
+protected:
+    virtual void _OnCloseInternal();
+    virtual void _OnClose();
+    virtual void _OnData(); // data received callback. Internal, should only be overloaded to call _OnRecv()
+    virtual void _OnRecv(void *buf, unsigned int size);
+    virtual void _OnOpen(); // called when opene
+    virtual bool _OnUpdate(); // called before reading from the socket
+
+    // new ones:
+    virtual void _OnRequestDone() {}
+
+    bool _Redirect(std::string loc, bool forceGET);
+
+    void _ProcessChunk();
+    bool _EnqueueOrSend(const Request& req, bool forceQueue = false);
+    void _DequeueMore();
+    bool _OpenRequest(const Request& req);
+    void _ParseHeader();
+    void _ParseHeaderFields(const char *s, size_t size);
+    bool _HandleStatus(); // Returns whether the processed request was successful, or not
+    void _FinishRequest();
+    void _OnRecvInternal(void *buf, unsigned int size);
+
+    std::string _user_agent;
+    std::string _accept_encoding; // Default empty.
+    std::string _tmpHdr; // used to save the http header if the incoming buffer was not large enough
+
+    unsigned int _keep_alive; // http related
+    unsigned int _remaining; // http "Content-Length: X" - already recvd. 0 if ready for next packet.
+                             // For chunked transfer encoding, this holds the remaining size of the current chunk
+    unsigned int _contentLen; // as reported by server
+    unsigned int _status; // http status code, HTTP_OK if things are good
+
+    std::queue<Request> _requestQ;
+    std::map<std::string, std::string> _hdrs; // Maps HTTP header fields to their values
+
+    Request _curRequest;
+
+    bool _inProgress;
+    bool _chunkedTransfer;
+    bool _mustClose; // keep-alive specified, or not
+    bool _followRedir; // Default true. Follow 3xx redirects if this is set.
+    bool _alwaysHandle; // Also deliver to _OnRecv() if a non-success code was received.
+    std::string _filename;
+    FILE* _pFile;
+};
+
+
+#endif
+
+// ------------------------------------------------------------------------
+
+#ifdef MINIHTTP_SUPPORT_SOCKET_SET
+
+/** \brief Support Multiple TCP Socket connections
+  * \ingroup SimpleHttpClient
+  *
+  * to Support multiple TCP Socket Connections
+  *
+  */
+class SocketSet
+{
+public:
+    virtual ~SocketSet();
+    void deleteAll();
+    bool update();
+    void add(TcpSocket *s, bool deleteWhenDone = true);
+    bool has(TcpSocket *s);
+    void remove(TcpSocket *s);
+    inline size_t size() { return _store.size(); }
+
+//protected:
+
+    struct SocketSetData
+    {
+        bool deleteWhenDone;
+        // To be extended
+    };
+
+    typedef std::map<TcpSocket*, SocketSetData> Store;
+
+    Store _store;
+};
+
+#endif
+
+} // end HttpClient namespace
+} // end openzwave namespace
+
+
+#endif
diff --git a/hardware/openzwave/platform/Log.h b/hardware/openzwave/platform/Log.h
index d9fd4a0b0d..271e8446f5 100644
--- a/hardware/openzwave/platform/Log.h
+++ b/hardware/openzwave/platform/Log.h
@@ -38,6 +38,12 @@ namespace OpenZWave
 {
 	class Mutex;
 	extern char const *LogLevelString[];
+
+	/** \brief Various LogLevels available to the Application
+	 * \ingroup Platform
+	 *
+	 * \see Log::SetLoggingState
+	 */
 	enum LogLevel
 	{
 		LogLevel_Invalid, 		/**< Invalid Log Status */
@@ -55,6 +61,12 @@ namespace OpenZWave
 		LogLevel_Internal		/**< Used only within the log class (uses existing timestamp, etc.) */
 	};
 
+	/** \brief A Abstract class to create a Custom Logging Method
+	 * \ingroup Platform
+	 *
+	 * Use this as the basis to create a custom logging class for your applation.
+	 * \see Log::SetLoggingClass
+	 */
 	class i_LogImpl
 	{
 	public:
@@ -68,12 +80,13 @@ namespace OpenZWave
 	};
 
 	/** \brief Implements a platform-independent log...written to the console and, optionally, a file.
+	 * \ingroup Platform
 	 */
 	class Log
 	{
 	public:
-		/**
-		 * Create a log.
+		/** \brief Create a log.
+		 *
 		 * Creates the cross-platform logging singleton.
 		 * Any previous log will be cleared.
 		 * \return a pointer to the logging object.
@@ -81,8 +94,8 @@ namespace OpenZWave
 		 */
 		static Log* Create( string const& _filename, bool const _bAppend, bool const _bConsoleOutput, LogLevel const _saveLevel, LogLevel const _queueLevel, LogLevel const _dumpTrigger );
 
-		/**
-		 * Create a log.
+		/** \brief Create a log.
+		 *
 		 * Creates the cross-platform logging singleton.
 		 * Any previous log will be cleared.
 		 * \param LogClass a Logging Class that inherits the i_LogImpl Class to use to Log
@@ -92,8 +105,8 @@ namespace OpenZWave
 
 		static Log* Create( i_LogImpl *LogClass );
 
-		/**
-		 * Destroys the log.
+		/** \brief Destroys the log.
+		 *
 		 * Destroys the logging singleton.  The log can no longer
 		 * be written to without another call to Create.
 		 * \see Create, Write
@@ -102,50 +115,53 @@ namespace OpenZWave
 
 		/**
 		 * \brief Set the Logging Implementation Class to replace the standard File/Console logging
+		 *
 		 * \param LogClass A Logging Class that inherits the i_LogImpl Class used to Log to
 		 * \return Bool Value indicating success or failure
 		 */
 		static bool SetLoggingClass(i_LogImpl *LogClass );
 
-		/**
-		 * \brief Enable or disable library logging (retained for backward compatibility)
+		/** \brief Enable or disable library logging (retained for backward compatibility)
+		 *
 		 * \param _dologging  If true, logging is enabled; if false, disabled
 		*/
 		static void SetLoggingState(bool _dologging);
 
-		/**
-		 * \brief Enable or disable library logging.  To disable, set _saveLevel and _queueLevel
-		 * to LogLevel_None.
+		/**\brief Enable or disable library logging.
+		 *
+		 * To disable, set _saveLevel and _queueLevel to LogLevel_None.
+		 *
 		 * \param _saveLevel	LogLevel of messages to write in real-time
 		 * \param _queueLevel	LogLevel of messages to queue to be dumped in case of an error
 		 * \param _dumpTrigger	LogLevel of message that triggers a queue dump (probably LogLevel_Error or LogLevel_Warning)
 		*/
 		static void SetLoggingState( LogLevel _saveLevel, LogLevel _queueLevel, LogLevel _dumpTrigger );
 
-		/**
-		 * \brief Determine whether logging is enabled or not (retained for backward compatibility)
+		/**\brief Determine whether logging is enabled or not (retained for backward compatibility)
+		 *
 		 * \param _dologging  If true, logging is enabled; if false, disabled
 		*/
 		static bool GetLoggingState();
 
-		/**
-		 * \brief Obtain the various logging levels.
+		/**\brief Obtain the various logging levels.
+		 *
 		 * \param _saveLevel	LogLevel of messages to write in real-time
 		 * \param _queueLevel	LogLevel of messages to queue to be dumped in case of an error
 		 * \param _dumpTrigger	LogLevel of message that triggers a queue dump (probably LogLevel_Error or LogLevel_Warning)
 		*/
 		static void GetLoggingState( LogLevel* _saveLevel, LogLevel* _queueLevel, LogLevel* _dumpTrigger );
 
-		/**
-		 * \brief Change the log file name.  This will start a new log file (or potentially start appending
+		/** \brief Change the log file name.
+		 *
+		 * This will start a new log file (or potentially start appending
 		 * information to an existing one.  Developers might want to use this function, together with a timer
 		 * in the controlling application, to create timestamped log file names.
 		 * \param _filename Name of the new (or existing) file to use for log output.
 		*/
 		static void SetLogFileName( const string &_filename );
 
-		/**
-		 * Write an entry to the log.
+		/**\brief Write an entry to the log.
+		 *
 		 * Writes a formatted string to the log.
 		 * \param _level	Specifies the type of log message (Error, Warning, Debug, etc.)
 		 * \param _format.  A string formatted in the same manner as used with printf etc.
@@ -154,8 +170,8 @@ namespace OpenZWave
 		 */
 		static void Write( LogLevel _level, char const* _format, ... );
 
-		/**
-		 * Write an entry to the log.
+		/**\brief Write an entry to the log.
+		 *
 		 * Writes a formatted string to the log.
 		 * \param _level	Specifies the type of log message (Error, Warning, Debug, etc.)
 		 * \param _nodeId	Node Id this entry is about.
@@ -165,8 +181,7 @@ namespace OpenZWave
 		 */
 		static void Write( LogLevel _level, uint8 const _nodeId, char const* _format, ... );
 
-		/**
-		 * Send the queued log messages to the log output.
+		/** \brief Send the queued log messages to the log output.
 		 */
 		static void QueueDump();
 
diff --git a/hardware/openzwave/platform/Mutex.h b/hardware/openzwave/platform/Mutex.h
index 43d50a7030..d445af847e 100644
--- a/hardware/openzwave/platform/Mutex.h
+++ b/hardware/openzwave/platform/Mutex.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class MutexImpl;
 
 	/** \brief Implements a platform-independent mutex--for serializing access to a shared resource.
+	 * \ingroup Platform
 	 */
 	class Mutex: public Wait
 	{
diff --git a/hardware/openzwave/platform/Ref.h b/hardware/openzwave/platform/Ref.h
index 57c32743a6..ce36772f8e 100644
--- a/hardware/openzwave/platform/Ref.h
+++ b/hardware/openzwave/platform/Ref.h
@@ -41,6 +41,7 @@ namespace OpenZWave
 	 * On construction, the reference count is set to one.  Calls to AddRef increment 
 	 * the count.  Calls to Release decrement the count.  When the count reaches
 	 * zero, the object is deleted.
+	 * \ingroup Platform
 	 */
 	class Ref
 	{
diff --git a/hardware/openzwave/platform/SerialController.h b/hardware/openzwave/platform/SerialController.h
index 9c42916cd6..0222244787 100644
--- a/hardware/openzwave/platform/SerialController.h
+++ b/hardware/openzwave/platform/SerialController.h
@@ -38,6 +38,9 @@ namespace OpenZWave
 	class Msg;
 	class SerialControllerImpl;
 
+	/** \brief Interface for controllers that implement a Serial Interface (USB Serial Port Emulation)
+	 * \ingroup Platform
+	 */
 	class SerialController: public Controller
 	{
 		friend class SerialControllerImpl;
diff --git a/hardware/openzwave/platform/Stream.h b/hardware/openzwave/platform/Stream.h
index 2465fa844c..1e7965d48d 100644
--- a/hardware/openzwave/platform/Stream.h
+++ b/hardware/openzwave/platform/Stream.h
@@ -38,6 +38,7 @@ namespace OpenZWave
 	class Mutex;
 
 	/** \brief Platform-independent definition of a circular buffer.
+	 * \ingroup Platform
 	 */
 	class Stream: public Wait
 	{
diff --git a/hardware/openzwave/platform/Thread.h b/hardware/openzwave/platform/Thread.h
index 936bd181b8..5213b3d438 100644
--- a/hardware/openzwave/platform/Thread.h
+++ b/hardware/openzwave/platform/Thread.h
@@ -38,6 +38,7 @@ namespace OpenZWave
 	class Event;
 
 	/** \brief Implements a platform-independent thread management class.
+	 * \ingroup Platform
 	 */
 	class Thread: public Wait
 	{
diff --git a/hardware/openzwave/platform/TimeStamp.h b/hardware/openzwave/platform/TimeStamp.h
index f3d0d22f84..ea8138d0d6 100644
--- a/hardware/openzwave/platform/TimeStamp.h
+++ b/hardware/openzwave/platform/TimeStamp.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class TimeStampImpl;
 
 	/** \brief Implements a platform-independent TimeStamp.
+	 * \ingroup Platform
 	 */
 	class OPENZWAVE_EXPORT TimeStamp
 	{
diff --git a/hardware/openzwave/platform/Wait.h b/hardware/openzwave/platform/Wait.h
index 2aff6bb558..1b3bfec806 100644
--- a/hardware/openzwave/platform/Wait.h
+++ b/hardware/openzwave/platform/Wait.h
@@ -37,6 +37,7 @@ namespace OpenZWave
 	class WaitImpl;
 
 	/** \brief Platform-independent definition of Wait objects.
+	 * \ingroup Platform
 	 */
 	class Wait: public Ref
 	{
diff --git a/hardware/openzwave/value_classes/Value.h b/hardware/openzwave/value_classes/Value.h
index c629ef584c..b8d4687b41 100644
--- a/hardware/openzwave/value_classes/Value.h
+++ b/hardware/openzwave/value_classes/Value.h
@@ -43,6 +43,7 @@ namespace OpenZWave
 	class Node;
 
 	/** \brief Base class for values associated with a node.
+	 * \ingroup ValueID
 	 */
 	class Value: public Ref
 	{
@@ -50,7 +51,7 @@ namespace OpenZWave
 		friend class ValueStore;
 
 	public:
-		Value( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _index, ValueID::ValueType const _type, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, bool const _isset, uint8 const _pollIntensity );
+		Value( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _index, ValueID::ValueType const _type, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, bool const _isset, uint8 const _pollIntensity );
 		Value();
 
 		virtual void ReadXML( uint32 const _homeId, uint8 const _nodeId, uint8 const _commandClassId, TiXmlElement const* _valueElement );
@@ -62,14 +63,14 @@ namespace OpenZWave
 		bool IsSet()const{ return m_isSet; }
 		bool IsPolled()const{ return m_pollIntensity != 0; }
 
-		string const& GetLabel()const{ return m_label; }
-		void SetLabel( string const& _label ){ m_label = _label; }
+		string const GetLabel()const;
+		void SetLabel( string const& _label, string const lang="");
 
 		string const& GetUnits()const{ return m_units; }
 		void SetUnits( string const& _units ){ m_units = _units; }
 
-		string const& GetHelp()const{ return m_help; }
-		void SetHelp( string const& _help ){ m_help = _help; }
+		string const GetHelp()const;
+		void SetHelp( string const& _help, string const lang="");
 
 		uint8 const& GetPollIntensity()const{ return m_pollIntensity; }
 		void SetPollIntensity( uint8 const& _intensity ){ m_pollIntensity = _intensity; }
@@ -106,12 +107,11 @@ namespace OpenZWave
 
 		time_t		m_refreshTime;			// time_t identifying when this value was last refreshed
 		bool		m_verifyChanges;		// if true, apparent changes are verified; otherwise, they're not
+		ValueID		m_id;
+
 
 	private:
-		ValueID		m_id;
-		string		m_label;
 		string		m_units;
-		string		m_help;
 		bool		m_readOnly;
 		bool		m_writeOnly;
 		bool		m_isSet;
diff --git a/hardware/openzwave/value_classes/ValueBitSet.h b/hardware/openzwave/value_classes/ValueBitSet.h
new file mode 100644
index 0000000000..2e0360e635
--- /dev/null
+++ b/hardware/openzwave/value_classes/ValueBitSet.h
@@ -0,0 +1,97 @@
+//-----------------------------------------------------------------------------
+//
+//	ValueBitSet.h
+//
+//	Represents a Range of Bits
+//
+//	Copyright (c) 2017 Justin Hammond <justin@dynam.ac>
+//
+//	SOFTWARE NOTICE AND LICENSE
+//
+//	This file is part of OpenZWave.
+//
+//	OpenZWave is free software: you can redistribute it and/or modify
+//	it under the terms of the GNU Lesser General Public License as published
+//	by the Free Software Foundation, either version 3 of the License,
+//	or (at your option) any later version.
+//
+//	OpenZWave is distributed in the hope that it will be useful,
+//	but WITHOUT ANY WARRANTY; without even the implied warranty of
+//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//	GNU Lesser General Public License for more details.
+//
+//	You should have received a copy of the GNU Lesser General Public License
+//	along with OpenZWave.  If not, see <http://www.gnu.org/licenses/>.
+//
+//-----------------------------------------------------------------------------
+
+#ifndef _ValueBitSet_H
+#define _ValueBitSet_H
+
+#include <string>
+#include <map>
+#include "Defs.h"
+#include "value_classes/Value.h"
+#include "Bitfield.h"
+
+class TiXmlElement;
+
+namespace OpenZWave
+{
+	class Msg;
+	class Node;
+	class CommandClass;
+
+	/** \brief BitSet value sent to/received from a node.
+	 * \ingroup ValueID
+	 */
+	class ValueBitSet: public Value
+	{
+	public:
+		ValueBitSet( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _index, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint32 const _value, uint8 const _pollIntensity );
+		ValueBitSet(){}
+		virtual ~ValueBitSet(){}
+
+		bool Set( uint32 const _value );
+		uint32 GetValue() const;
+
+		bool SetBit( uint8 const _idx);
+		bool ClearBit(uint8 const _idx);
+		bool GetBit(uint8 _idx) const;
+
+		bool SetBitMask(uint32 _bitMask);
+		uint32 GetBitMask() const;
+
+		void OnValueRefreshed( uint32 const _value );
+
+		// From Value
+		virtual string const GetAsString() const;
+		virtual string const GetAsBinaryString() const;
+		virtual bool SetFromString( string const& _value );
+		virtual void ReadXML( uint32 const _homeId, uint8 const _nodeId, uint8 const _commandClassId, TiXmlElement const* _valueElement );
+		virtual void WriteXML( TiXmlElement* _valueElement );
+
+		string GetBitHelp(uint8 _idx);
+		bool SetBitHelp(uint8 _idx, string help);
+		string GetBitLabel(uint8 _idx);
+		bool SetBitLabel(uint8 _idx, string label);
+
+		uint8 GetSize() const;
+		void SetSize(uint8 size);
+
+	private:
+		bool isValidBit(uint8 _idx) const;
+		Bitfield		m_value;				// the current index in the m_items vector
+		Bitfield		m_valueCheck;			// the previous value (used for double-checking spurious value reads)
+		Bitfield		m_newValue;				// a new value to be set on the appropriate device
+		uint32			m_BitMask;				// Valid Bits
+		uint8 			m_size;					// Number of bytes in size
+		vector<int32>   m_bits;
+	};
+
+} // namespace OpenZWave
+
+#endif
+
+
+
diff --git a/hardware/openzwave/value_classes/ValueBool.h b/hardware/openzwave/value_classes/ValueBool.h
index 42f6427538..070d0d4a6b 100644
--- a/hardware/openzwave/value_classes/ValueBool.h
+++ b/hardware/openzwave/value_classes/ValueBool.h
@@ -41,11 +41,12 @@ namespace OpenZWave
 	class CommandClass;
 
 	/** \brief Boolean value sent to/received from a node.
+	 * \ingroup ValueID
 	 */
 	class ValueBool: public Value
 	{
 	public:
-		ValueBool( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _index, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, bool const _value, uint8 const _pollIntensity );
+		ValueBool( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _index, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, bool const _value, uint8 const _pollIntensity );
 		ValueBool(){}
 		virtual ~ValueBool(){}
 
diff --git a/hardware/openzwave/value_classes/ValueButton.h b/hardware/openzwave/value_classes/ValueButton.h
index d2231e4fd2..842a7f3b28 100644
--- a/hardware/openzwave/value_classes/ValueButton.h
+++ b/hardware/openzwave/value_classes/ValueButton.h
@@ -40,12 +40,13 @@ namespace OpenZWave
 	class Node;
 	class CommandClass;
 
-	/** \brief Button value ???.
+	/** \brief Button value
+	 * \ingroup ValueID
 	 */
 	class ValueButton: public Value
 	{
 	public:
-		ValueButton( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _index, string const& _label, uint8 const _pollIntensity );
+		ValueButton( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _index, string const& _label, uint8 const _pollIntensity );
 		ValueButton(): m_pressed( false ){}
 		virtual ~ValueButton(){}
 
diff --git a/hardware/openzwave/value_classes/ValueByte.h b/hardware/openzwave/value_classes/ValueByte.h
index 2eda03c016..8bbbff601a 100644
--- a/hardware/openzwave/value_classes/ValueByte.h
+++ b/hardware/openzwave/value_classes/ValueByte.h
@@ -40,11 +40,12 @@ namespace OpenZWave
 	class Node;
 
 	/** \brief Byte value sent to/received from a node.
+	 * \ingroup ValueID
 	 */
 	class ValueByte: public Value
 	{
 	public:
-		ValueByte( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _index, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint8 const _value, uint8 const _pollIntensity );
+		ValueByte( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _index, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint8 const _value, uint8 const _pollIntensity );
 		ValueByte();
 		virtual ~ValueByte(){}
 
diff --git a/hardware/openzwave/value_classes/ValueDecimal.h b/hardware/openzwave/value_classes/ValueDecimal.h
index fec4a20058..832bcefbfc 100644
--- a/hardware/openzwave/value_classes/ValueDecimal.h
+++ b/hardware/openzwave/value_classes/ValueDecimal.h
@@ -40,6 +40,7 @@ namespace OpenZWave
 	class Node;
 
 	/** \brief Decimal value sent to/received from a node.
+	 * \ingroup ValueID
 	 */
 	class ValueDecimal: public Value
 	{
@@ -49,7 +50,7 @@ namespace OpenZWave
 		friend class ThermostatSetpoint;
 
 	public:
-		ValueDecimal( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _index, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, string const& _value, uint8 const _pollIntensity );
+		ValueDecimal( uint32 const _homeId, uint8 const _nodeId, ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _index, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, string const& _value, uint8 const _pollIntensity );
 		ValueDecimal(): m_precision( 0 ){}
 		virtual ~ValueDecimal(){}
 
